import time
import sys
import socket

import subprocess

# filename looks like this: /LIGHT/light/at_klosterneuburg_1_2013_0310_135047.csv

# archive looks like this: WD+SN+"_archive"+lastmontharch+".tgz"
# e.g.: /LIGHT/light/AT_LEBMIN_3_archive_2017-04.tgz


#working directory
WD="/LIGHT/light/"

#station's name
SN=(socket.gethostname()).strip()
SN=SN.replace("-","_")

#string of today's date/time
today = time.strftime("%Y-%m-%d %H:%M:%S UTC",time.gmtime(time.time()))
#unique identifier for last month's data files
lastmonthfile = time.strftime("_%Y_%m",time.gmtime(time.time()-30*24*3600))
#unique identifier for last month's archive
lastmontharch = time.strftime("_%Y-%m",time.gmtime(time.time()-30*24*3600))


#do not do this near month-edges. just because.
dom = int(time.strftime("%d",time.gmtime(time.time())))
if dom in (1,2,3,29,30,31):
    sys.exit(0) #bad hair day? exit silently.


#check if archive already exists:
try:
    archive=subprocess.check_output("ls "+WD+SN+"_archive"+lastmontharch+".tgz", shell=True)
    if filelist.strip() != "":
        sys.exit(0) #so, we really found last month's archive. exit silently.
except: #file-not-found raises error, which is nice
    pass #if not found, let's create an archive! 


#check file list for not-emptyness
try:
    filelist=subprocess.check_output("ls "+WD+"*"+lastmonthfile+"*_*.csv", shell=True)
    if filelist.strip() == "": raise IOError #empty file list and no error? strange! raise error!
except:
    sys.exit(1) #no file, no archive. exit semi-silently (1)


#try to make archive. compress data and delete source files ("--remove" flag)
try:
    a=subprocess.check_output("tar -czf "+WD+SN+"_archive"+lastmontharch+".tgz "+WD+"*"+lastmonthfile+"*_*.csv --remove", shell=True)
except:
    print(today+"  ---  Archiver: Input file error. Exiting.")
    sys.exit(1)


#made it all this way down here? great!
print(today+"  ---  Archive successfully created.")
sys.stdout.flush()


